classification
Title: fix crash with continue in nested try/finally
Type: Stage:
Components: Interpreter Core Versions: Python 2.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: arigo, complex, georg.brandl, nnorwitz, twouters
Priority: high Keywords: patch

Created on 2006-08-18 07:27 by nnorwitz, last changed 2007-03-05 08:28 by nnorwitz. This issue is now closed.

Files
File name Uploaded Description Edit
finally.diff nnorwitz, 2006-08-18 07:27 v1 (really two :-)
Messages (10)
msg50932 - (view) Author: Neal Norwitz (nnorwitz) * (Python committer) Date: 2006-08-18 07:27
Based on mail from python-dev.

http://mail.python.org/pipermail/python-dev/2006-August/068306.html

def test():
   for abc in range(10):
       try: pass
       finally:
           try:
               continue
           except:
               pass

crashes.
msg50933 - (view) Author: Armin Rigo (arigo) * (Python committer) Date: 2006-08-19 08:04
Logged In: YES 
user_id=4771

My two cents are a meta-note: I think that this should not go
into 2.5.0.  It fixes a bug with syntactically invalid
code, which nobody stumbled upon until recently although
it has been here for ages, and there is a (small) risk to
break syntactically valid code.
msg50934 - (view) Author: Neal Norwitz (nnorwitz) * (Python committer) Date: 2006-08-19 15:08
Logged In: YES 
user_id=33168

I've been thinking similarly.  I didn't even update the
import magic for this.

Did you get a chance to review the patch?  It would be nice
to get this into 2.6 and then we can figure out if this
should go into 2.5.0 (probably not) or 2.5.1 (probably in my
current thinking), or just leave it for 2.6.
msg50935 - (view) Author: Thomas Wouters (twouters) * (Python committer) Date: 2006-08-21 19:37
Logged In: YES 
user_id=34209

I think we should just check this in in 2.5.0. It looks
fine, it's the simple and correct fix, and I don't see how
it could break legitimate code. It's not a complex piece of
code.
msg50936 - (view) Author: Neal Norwitz (nnorwitz) * (Python committer) Date: 2006-08-21 19:48
Logged In: YES 
user_id=33168

Committed revision 51439. (2.6)

Thomas Wouters thinks this is fine to go in 2.5.  I'll leave
open for now until we decide what to do.
msg50937 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2006-09-30 08:48
Logged In: YES 
user_id=849994

Time to checkin for 2.5.1?
msg50938 - (view) Author: Neal Norwitz (nnorwitz) * (Python committer) Date: 2006-10-08 00:49
Logged In: YES 
user_id=33168

Georg, if you don't mind doing this, I think it's fine to go
into 2.5.1.  I'll try to get around to it at some point if not.
msg50939 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2006-10-08 07:06
Logged In: YES 
user_id=849994

Committed rev. 52220 in 2.5 branch. Closing now.
msg50940 - (view) Author: Viktor Ferenczi (complex) Date: 2007-03-04 23:21
Example code crashes Python 2.5 (r25:51908, Sep 19 2006, 09:52:17) [MSC v.1310 32 bit (Intel)], but this bug is closed as fixed. Is this OK? (Maybe I missed something, but this bug still exists...)
msg50941 - (view) Author: Neal Norwitz (nnorwitz) * (Python committer) Date: 2007-03-05 08:28
The bug was fixed after 2.5 was released.  The fix is in SVN currently and will be part of the 2.5.1 release.
History
Date User Action Args
2006-08-18 07:27:49nnorwitzcreate